/* Exception Vectors
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Image Loader.

The Imote2 Image Loader is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

The Imote2 Image Loader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with the Imote2 Image Loader. If not, see <http://www.gnu.org/licenses/>.
*/

.equ VECTOR_ADDRS,(0x20)

/* exception vectors */
.section .vectors
.globl _bootvectors
_bootvectors:
	/* reset exception (RESET) */
	ldr pc,[pc,#VECTOR_ADDRS-8]
	/* undefined instruction (UNDEF) */
	ldr pc,[pc,#VECTOR_ADDRS-8]
	/* software interrupt (SWI) */
	ldr pc,[pc,#VECTOR_ADDRS-8]
	/* prefetch (instruction) abort (PABORT) */
	ldr pc,[pc,#VECTOR_ADDRS-8]
	/* data abort (DABORT) */
	ldr pc,[pc,#VECTOR_ADDRS-8]
	/* reserved */
	ldr pc,[pc,#VECTOR_ADDRS-8]
	/* interrupt request (IRQ) */
	ldr pc,[pc,#VECTOR_ADDRS-8]
	/* fast interrupt request (FIQ) */
	ldr pc,[pc,#VECTOR_ADDRS-8]

.section .vecaddrs
.globl _vectoraddresses
_vectoraddresses:
	.long _start
	.long hplarmv_undef
	.long hplarmv_swi
	.long hplarmv_pabort
	.long hplarmv_dabort
	.long 0x0
	.long hplarmv_irq
	.long hplarmv_fiq
